//------------------------------------------------------------------------------
// GPL LISENCE (short)
//------------------------------------------------------------------------------
/*
 * Copyright (c) 2014 R1KO

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 * ChangeLog:
		1.0.0 -	Релиз
		1.0.1 -	Исправлена ошибка с переводом при работе с ядром 1.1.2 R
		1.0.2 -	Изменена фраза в переводе
				Оптимизация работы с ядром 1.1.2 R
*/

#pragma semicolon 1

#include <sourcemod>
#include <cstrike>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] Respawn",
	author = "R1KO",
	version = "1.0.2"
};

#define VIP_RESPAWN				"Respawn"

new g_iClientRespawns[MAXPLAYERS+1];

public OnPluginStart()
{
	RegConsoleCmd("respawn", Respawn_CMD);

	HookEventEx("round_start", Event_RoundStart, EventHookMode_PostNoCopy);

	LoadTranslations("vip_core.phrases");
	LoadTranslations("vip_modules.phrases");
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_RESPAWN, INT, SELECTABLE, OnSelectItem, OnDisplayItem, OnDrawItem);
}

public Action:Respawn_CMD(iClient, args)
{
	if(iClient)
	{
		if(VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, VIP_RESPAWN))
		{
			RespawnClient(iClient);
		}
		else
		{
			PrintToChat(iClient, "%t%t", "VIP_CHAT_PREFIX", "COMMAND_NO_ACCESS");
		}
	}
	return Plugin_Handled;
}

public Event_RoundStart(Handle:hEvent, const String:name[], bool:dontBroadcast)
{
	for(new i = 1; i <= MaxClients; i++) g_iClientRespawns[i] = 0;
}

public OnClientPutInServer(iClient)
{
	g_iClientRespawns[iClient] = 0;
}

bool:RespawnClient(iClient)
{
	new iTeam = GetClientTeam(iClient);
	if(iTeam > 1)
	{
		if(IsPlayerAlive(iClient) == false)
		{
			if(g_iClientRespawns[iClient] < VIP_GetClientFeatureInt(iClient, VIP_RESPAWN))
			{
				CS_RespawnPlayer(iClient);
				++g_iClientRespawns[iClient];
				return true;
			}
			else
			{
				PrintToChat(iClient, "%tДостигнут лимит использований за раунд!", "VIP_CHAT_PREFIX");
			}
		}
		else
		{
			PrintToChat(iClient, "%tВы должны быть мертвы!", "VIP_CHAT_PREFIX");
		}
	}
	else
	{
		PrintToChat(iClient, "%tВы должны быть в команде!", "VIP_CHAT_PREFIX");
	}
	return false;
}


public bool:OnSelectItem(iClient, const String:sFeatureName[])
{
	RespawnClient(iClient);
	return true;
}

public bool:OnDisplayItem(iClient, const String:sFeatureName[], String:sDisplay[], maxlen)
{
	if(VIP_GetClientFeatureStatus(iClient, sFeatureName) == ENABLED)
	{
		SetGlobalTransTarget(iClient);
		FormatEx(sDisplay, maxlen, "%t [%t]", "Respawn", "Left", (VIP_GetClientFeatureInt(iClient, VIP_RESPAWN)-g_iClientRespawns[iClient]));
		return true;
	}

	return false;
}

public OnDrawItem(iClient, const String:sFeatureName[], iStyle)
{
	if(VIP_GetClientFeatureStatus(iClient, sFeatureName) != NO_ACCESS && g_iClientRespawns[iClient] >= VIP_GetClientFeatureInt(iClient, VIP_RESPAWN))
	{
		return ITEMDRAW_DISABLED;
	}

	return iStyle;
}